# Server Pages

Converts a [CSV](server-pages.csv) containing information about my 
server pages into a JSON containing information about the pages' 
status, update time and server uptime. Created for use on my personal 
website's [server information page].

[server information page]: https://kevin-mok.com/server/

## Sample Output
Running `node server-status.js` (after `npm i`) would produce the 
following output:
``` json
{
  "sites": [
    {
      "shortUrl": "kevin-mok.com",
      "url": "https://kevin-mok.com",
      "siteTitle": " Kevin Mok ",
      "description": "Personal site (this site).",
      "repo": "Kevin-Mok/my-site",
      "repoUrl": "https://git.kevin-mok.com/Kevin-Mok/my-site",
      "status": "up"
    },
    ...
  ],
  "updateTime": 1569209941343,
  "upSince": "2019-09-22 19:30:10"
}
```

## Built With

* [csvtojson]
* [url-metadata] - Fetch pages for their titles.

[csvtojson]: https://www.npmjs.com/package/csvtojson
[url-metadata]: https://www.npmjs.com/package/url-metadata
